//
// $Id: file.h 101 2008-07-10 09:20:12Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

//----------------------------------------------------------------------------
#ifndef FILEH
#define FILEH

#include <string>
#include "parameter.h"
#include "xy.h"

//----------------------------------------------------------------------------
typedef enum { TTUNKNOWN, TTREGULAR, TTHARD, TTSOFT, TTOUTSIDE } TTinTyp;

//----------------------------------------------------------------------------
bool			LoadPar(std::string FileName, std::vector<std::string> *ParList);

bool 			LoadPRJ(std::string FileName, int DebugLevel);

bool			LoadDGM(std::string FileName, TNodeList *NodeList, TElementList *ElementList, TXYZList *XyList, int DebugLevel);
bool			LoadDGMTIN(std::string FileName, TNodeList *NodeList, TElementList *ElementList, TXYZList *XyList, int DebugLevel);
bool			LoadDGMGRD(std::string FileName, TNodeList *NodeList, TXYZList *XyList, int DebugLevel);
bool			LoadDGMXYZ(std::string FileName, TNodeList *NodeList, TXYZList *XyList, int DebugLevel);
bool			LoadDGMSHP(std::string FileName, TNodeList *NodeList, TXYZList *XyList, int DebugLevel);
bool			LoadDGM2DM(std::string FileName, TNodeList *NodeList, TElementList *ElementList, TXYZList *XyList, int DebugLevel);

bool 			LoadProfile(std::string FileName, TProfilList* ProfilList, TGewaesserAchseList* GewaesserAchseList, double VonKmD, double BisKmD, int DebugLevel);
bool 			LoadLinien(std::string FileName, TProfilList* SperrenList, TProfilList* GrabenList, TProfilList* Rohre1List, TProfilList* Rohre2List, int DebugLevel);

bool 			LoadWsp(std::string FileName, TProfilList* ProfilList, std::string Tag, int DebugLevel);
bool 			LoadWspTxt(std::string FileName, TProfilList* ProfilList, int DebugLevel);
bool 			LoadWspDBF(std::string FileName, TProfilList* ProfilList, int DebugLevel);
bool 			LoadWspWst(std::string FileName, TProfilList* ProfilList, std::string Tag, int DebugLevel);

bool			LoadAchse(std::string FileName, TGewaesserAchseList* GewaesserAchseList, int DebugLevel);

bool			LoadGebiet(std::string FileName, TXYZList *XyList, int DebugLevel);

bool 			SavePRJ(std::string FileName, int DebugLevel);
bool 			SaveNet(std::string FileName, TNodeList *NodeList, TElementList *ElementList, int DebugLevel);
bool 			SaveSol(std::string FileName, TNodeList *NodeList, int DebugLevel);
bool 			SaveNodes(std::string FileName, TNodeList *NodeList, int DebugLevel);
bool 			SaveElements(std::string FileName, TElementList *ElementList, int TopoDiff, int DebugLevel);
bool 			SaveProfile(std::string FileName, TProfilList *ProfilList, int DebugLevel);
bool 			SavePolygon(std::string FileName, TXYZList *XyList, int DebugLevel);
bool 			SavePolygone(std::string FileName, TErgebnisPolygonList *ErgebnisPolygonList, int DebugLevel);
bool 			SaveEdges(std::string FileName, TEdgeList *EdgeList, int DebugLevel);
bool 			SaveXml(std::string FileName, TParameter* Parameter);

//----------------------------------------------------------------------------
#endif
