//
// $Id: test.cpp 87 2007-06-07 08:36:13Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

//---------------------------------------------------------------------------
#include <stdio.h>
#include "tools.h"
#include "test.h"

#include <stdexcept>

int ReturnCode = 0;

FILE *fhlog = 0;
FILE *fhsta = 0;

//---------------------------------------------------------------------
int main(unsigned int argc, char **argv)
{
	// Alle Fehler und normalen Ausgaben werden in stderr geschrieben,
	// damit die Testausgaben auf stdout gehen knnen.
	fhlog = stderr;
	fhsta = stderr;

	try
	{
		if (argc <= 1 || strncmp(argv[1], "tools", 5) == 0)		test_tools();
		if (argc <= 1 || strncmp(argv[1], "xy", 2) == 0)		test_xy();
		if (argc <= 1 || strncmp(argv[1], "profil", 6) == 0)	test_profil();
		if (argc <= 1 || strncmp(argv[1], "nodes", 5) == 0)		test_nodes();
		if (argc <= 1 || strncmp(argv[1], "quadtree", 8) == 0)	test_quadtree();
		if (argc <= 1 || strncmp(argv[1], "file", 4) == 0)		test_file();
		if (argc <= 1 || strncmp(argv[1], "tri", 3) == 0)		test_tri();
		if (argc <= 1 || strncmp(argv[1], "qhull", 5) == 0)		test_qhull();
	}
	catch (const std::runtime_error& e)
	{
		write_fortschritt ("Fehler wurde korrekt abgefangen\n");
		write_fortschritt ("Programmabbruch\n");
	}
	catch (const std::length_error& e)
	{
		write_fortschritt ("Es steht leider nicht genug Speicher zur Verfgung\n", e.what());
		write_fortschritt ("Fehler wurde korrekt abgefangen\n");
		write_fortschritt ("Programmabbruch\n");
	}
	catch (const std::exception& e)
	{
		write_fortschritt ("%s\n", e.what());
		write_fortschritt ("Fehler wurde korrekt abgefangen\n");
		write_fortschritt ("Bitte informieren sie den Programmierer\n");
		write_fortschritt ("Programmabbruch\n");
	}
	catch (...)
	{
		write_fortschritt ("Unbekannter Fehler wurde korrekt abgefangen\n");
		write_fortschritt ("Bitte informieren sie den Programmierer\n");
		write_fortschritt ("Programmabbruch\n");

		ReturnCode = 2;
	}

	return (ReturnCode);
}

