//
// $Id: test_file.cpp 107 2008-07-21 21:24:19Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#include <stdio.h>

#include "tools.h"
#include "xy.h"
#include "parameter.h"
#include "file.h"

//----------------------------------------------------------------------------
#ifdef __BORLANDC__
#define POLYGONFILE		"test_daten\\ergebnispolygone.shp"
#define DGMTINFILE		"test_daten\\dgmtin\\tnxy.adf"
#define DGMTINFILE2		"test_daten\\dgmtin2\\tnxy.adf"
#define DGMTINFILE3		"test_daten\\dgmtin3\\tnxy.adf"
#define DGMGRDFILE		"test_daten\\dgm.grd"
#define DGMXYZFILE		"test_daten\\dgm.xyz"
#define DGMXYZFILE2		"test_daten\\dgm_gross.xyz"
#define DGMXYZFILE3		"test_daten\\dgm_ziemlich_gross.xyz"
#define DGMXYZFILE4		"test_daten\\dgm_sehr_gross.xyz"
#define DGMSHPFILE		"test_daten\\dgm.shp"
#define DGMSHPFILE2		"test_daten\\dgm2.shp"
#define DGMXYZFILE4		"test_daten\\dgm_sehr_gross.xyz"
#define DGM2DMFILE		"test_daten\\dgm.2dm"
#define PROFILFILE		"test_daten\\profile.shp"
#define PROFILZFILE		"test_daten\\profilez.shp"
#define PROFILFILE2		"test_daten\\profile_dreh.shp"
#define LINIENFILE		"test_daten\\linien.shp"
#define LINIENFILE3		"test_daten\\linien3.shp"
#define WSPFILE			"test_daten\\wsp.txt"
#define WSPFILE2		"test_daten\\wsp.dbf"
#define WSPFILE3		"test_daten\\mosel.wst"
#define WSPFILE4		"test_daten\\test.wst"
#define WSPFILE5		"test_daten\\DEMO-HWM.wst"
#define ACHSEFILE		"test_daten\\achse.shp"
#define GRENZEFILE		"test_daten\\hydgrenze.shp"
#define GRENZEFILE2		"test_daten\\hydgrenze2.shp"
#else
#define POLYGONFILE		"test_daten/ergebnispolygone.shp"
#define DGMTINFILE		"test_daten/dgmtin/tnxy.adf"
#define DGMTINFILE2		"test_daten/dgmtin2/tnxy.adf"
#define DGMTINFILE3		"test_daten/dgmtin3/tnxy.adf"
#define DGMGRDFILE		"test_daten/dgm.grd"
#define DGMXYZFILE		"test_daten/dgm.xyz"
#define DGMXYZFILE2		"test_daten/dgm_gross.xyz"
#define DGMXYZFILE3		"test_daten/dgm_ziemlich_gross.xyz"
#define DGMXYZFILE4		"test_daten/dgm_sehr_gross.xyz"
#define DGMSHPFILE		"test_daten/dgm.shp"
#define DGMSHPFILE2		"test_daten/dgm2.shp"
#define DGM2DMFILE		"test_daten/dgm.2dm"
#define PROFILFILE		"test_daten/profile.shp"
#define PROFILZFILE		"test_daten/profilez.shp"
#define PROFILFILE2		"test_daten/profile_dreh.shp"
#define LINIENFILE		"test_daten/linien.shp"
#define LINIENFILE3		"test_daten/linien3.shp"
#define WSPFILE			"test_daten/wsp.txt"
#define WSPFILE2		"test_daten/wsp.dbf"
#define WSPFILE3		"test_daten/mosel.wst"
#define WSPFILE4		"test_daten/test.wst"
#define WSPFILE5		"test_daten/DEMO-HWM.wst"
#define ACHSEFILE		"test_daten/achse.shp"
#define GRENZEFILE		"test_daten/hydgrenze.shp"
#define GRENZEFILE2		"test_daten/hydgrenze2.shp"
#endif

//---------------------------------------------------------------------
void test_file(void)
{
	////////////////////////////////////////
	// Test der Dateiein- und ausgabe
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test Datei Ein- und Ausgabe\n");

	/////////////////////////////////////////////////
	// Test von Ergebnispolygon schreiben
	/////////////////////////////////////////////////

	{
		printf ("Test Ergebnispolygon schreiben:                                      ");

		TErgebnisPolygonList *PolygonList = new TErgebnisPolygonList;

		TErgebnisPolygon* EP1 = new TErgebnisPolygon(0);
		TXYZ *XY1 = new TXYZ(10000, 10000);
		EP1->Add(XY1);
		TXYZ *XY2 = new TXYZ(30000, 10000);
		EP1->Add(XY2);
		TXYZ *XY3 = new TXYZ(30000, 30000);
		EP1->Add(XY3);
		TXYZ *XY4 = new TXYZ(10000, 30000);
		EP1->Add(XY4);
		PolygonList->push_back(EP1);

		TErgebnisPolygon* EP2 = new TErgebnisPolygon(0);
		TXYZ *XY5 = new TXYZ(15000, 15000);
		EP2->Add(XY5);
		TXYZ *XY6 = new TXYZ(25000, 15000);
		EP2->Add(XY6);
		TXYZ *XY7 = new TXYZ(25000, 25000);
		EP2->Add(XY7);
		TXYZ *XY8 = new TXYZ(15000, 25000);
		EP2->Add(XY8);
		TXYZ *XY9 = new TXYZ(20000, 20000);
		EP2->Add(XY9);
		PolygonList->push_back(EP2);

		TErgebnisPolygon* EP3 = new TErgebnisPolygon(0);
		TXYZ *XY10 = new TXYZ(45000, 25000);
		EP3->Add(XY10);
		TXYZ *XY11 = new TXYZ(55000, 25000);
		EP3->Add(XY11);
		TXYZ *XY12 = new TXYZ(55000, 15000);
		EP3->Add(XY12);
		PolygonList->push_back(EP3);

		SavePolygone(POLYGONFILE, PolygonList, 9);

		FILE* fh = fopen(POLYGONFILE, "r");
		unsigned char V;
		unsigned long CheckSum = 0;
		while (1 == fread(&V, sizeof(V), 1, fh))
        {
			CheckSum = CheckSum + V;
        }
        fclose(fh);

		if (CheckSum != 10322)			printf("Failed\n");
		else							printf("Pass\n");

		delete PolygonList;
	}

	/////////////////////////////////////////////////
	// Test von Parameterdatei laden
	/////////////////////////////////////////////////

	{
		printf ("Test Parameterdatei laden:                                           ");

		char test1[80] = "test";
		char test2[80] = "-par=test_daten\\test.par";
		char *test3 = 0;
		char *argv[3] = {test1, test2, test3};

		TParameter *Parameter = new TParameter(2, argv);

		if (!Parameter->IsSetPar)															printf("Failed\n");
		else if (!Parameter->IsSetDgm || Parameter->FileNameDgm != "egal.shp")				printf("Failed\n");
		else if (!Parameter->IsSetPro || Parameter->FileNamePro != "egal.shp")				printf("Failed\n");
		else if (!Parameter->IsSetWsp || Parameter->FileNameWsp != "egal.shp")				printf("Failed\n");
		else if (!Parameter->IsSetAchse || Parameter->FileNameAchse != "egal.shp")			printf("Failed\n");
		else if (!Parameter->IsSetGebiet || Parameter->FileNameGebiet != "total egal.shp")	printf("Failed\n");
		else if (!Parameter->IsSetGel || Parameter->Sperre != true)							printf("Failed\n");
		else if (!Parameter->IsSetDelta)													printf("Failed\n");
		else if (Parameter->Von != 0 || Parameter->Bis != 100 || Parameter->Diff != 23)		printf("Failed\n");
		else if (!Parameter->IsSetStrecke)													printf("Failed\n");
		else if (Parameter->VonKm != 123.34 || Parameter->BisKm != 123.78)					printf("Failed\n");
		else if (!Parameter->IsSetAusgabe || Parameter->FileNameAusgabe != "egal.shp")		printf("Failed\n");
		else if (!Parameter->IsSetSaveTri)													printf("Failed\n");
		else																				printf("Pass\n");

		delete Parameter;
	}

	////////////////////////////////////////
	// Test von Profilspuren laden
	////////////////////////////////////////

	{
		printf ("Test Profilspuren laden:                                             ");

		TProfilList *ProfilList = new TProfilList();

		LoadProfile(PROFILFILE, ProfilList, 0, -9999.9, 9999.9, 8);

		if (ProfilList->size() != 8)	printf("Failed\n");
		else							printf("Pass\n");

		delete ProfilList;
	}

	////////////////////////////////////////
	// Test von Profilspuren laden
	////////////////////////////////////////

	{
		printf ("Test Z-Profilspuren laden:                                           ");

		TProfilList *ProfilList = new TProfilList();

		LoadProfile(PROFILZFILE, ProfilList, 0, -9999.9, 9999.9, 8);

		if (ProfilList->size() != 5)	printf("Failed\n");
		else							printf("Pass\n");

		delete ProfilList;
	}

	////////////////////////////////////////
	// Test von Profilspuren laden
	////////////////////////////////////////

/*
	{
		printf ("Test Profilspuren laden mit ausrichten:                              ");

		TGewaesserAchseList *AchsenList = new TGewaesserAchseList();

		LoadAchse(ACHSEFILE, AchsenList, 8);

		TProfilList *ProfilList = new TProfilList();

		LoadProfile(PROFILFILE2, ProfilList, AchsenList, -9999.9, 9999.9, 9);

		if (ProfilList->size() != 8)	printf("Failed\n");
		else							printf("Pass\n");

		delete ProfilList;
		delete AchsenList;
	}
*/

	////////////////////////////////////////
	// Test von Strukturen laden
	////////////////////////////////////////

	{
		printf ("Test Strukturen als Linien laden:                                    ");

		TProfilList *SperrenList = new TProfilList();
		TProfilList *GrabenList = new TProfilList();
		TProfilList *RohreList = new TProfilList();
		TProfilList *GradientenList = new TProfilList();

		LoadLinien(LINIENFILE, SperrenList, GrabenList, RohreList, GradientenList, 8);

		if (SperrenList->size() != 5)			printf("Failed\n");
		else if (GrabenList->size() != 4)		printf("Failed\n");
		else if (RohreList->size() != 0)		printf("Failed\n");
		else if (GradientenList->size() != 0)	printf("Failed\n");
		else									printf("Pass\n");

		delete GradientenList;
		delete RohreList;
		delete GrabenList;
		delete SperrenList;
	}

	{
		printf ("Test Strukturen als Polygone laden:                                  ");

		TProfilList *SperrenList = new TProfilList();
		TProfilList *GrabenList = new TProfilList();
		TProfilList *RohreList = new TProfilList();
		TProfilList *GradientenList = new TProfilList();

		LoadLinien(LINIENFILE3, SperrenList, GrabenList, RohreList, GradientenList, 8);

		int SperrenSumme = 0;
		for (TProfilList::iterator i=SperrenList->begin(); i != SperrenList->end(); i++)
		{
			TProfil *Profil = *i;

			for (TPointList::iterator j = Profil->PointList->begin(); j != Profil->PointList->end(); j++)
			{
				TPoint* Point = *j;

				SperrenSumme = SperrenSumme + Point->Z;
			}
		}

		int GrabenSumme = 0;
		for (TProfilList::iterator i=GrabenList->begin(); i != GrabenList->end(); i++)
		{
			TProfil *Profil = *i;

			for (TPointList::iterator j = Profil->PointList->begin(); j != Profil->PointList->end(); j++)
			{
				TPoint* Point = *j;

				GrabenSumme = GrabenSumme + Point->Z;
			}
		}

		if (SperrenList->size() != 1)			printf("Failed\n");
		else if (GrabenList->size() != 1)		printf("Failed\n");
		else if (RohreList->size() != 0)		printf("Failed\n");
		else if (GradientenList->size() != 0)	printf("Failed\n");
		else if (SperrenSumme != 22000)			printf("Failed\n");
		else if (GrabenSumme != 29000)			printf("Failed\n");
		else									printf("Pass\n");

		delete GradientenList;
		delete RohreList;
		delete GrabenList;
		delete SperrenList;
	}

	////////////////////////////////////////
	// Test von WSP als ASCII laden
	////////////////////////////////////////

	{
		printf ("Test Wasserstnde als TXT laden:                                     ");

		TProfilList *WspList = new TProfilList();

		LoadWsp(WSPFILE, WspList, "", 8);

		if (WspList->size() != 2834)	printf("Failed\n");
		else							printf("Pass\n");

		delete WspList;
	}

	////////////////////////////////////////
	// Test von WSP als DBF laden
	////////////////////////////////////////

	{
		printf ("Test Wasserstnde als DBF laden:                                     ");

		TProfilList *WspList = new TProfilList();

		LoadWsp(WSPFILE2, WspList, "", 8);

		if (WspList->size() != 32)	printf("Failed\n");
		else						printf("Pass\n");

		delete WspList;
	}

	////////////////////////////////////////
	// Test von WSP als WST laden
	////////////////////////////////////////

	{
		printf ("Test Wasserstnde als WST laden:                                     ");

		TProfilList *WspList = new TProfilList();

		LoadWsp(WSPFILE3, WspList, "W(HQ100)", 8);

		if (WspList->size() != 2375)	printf("Failed\n");
		else							printf("Pass\n");

		delete WspList;
	}

	////////////////////////////////////////
	// Test von WSP als WST (neues Format) laden
	////////////////////////////////////////

	{
		printf ("Test Wasserstnde als WST laden:                                     ");

		TProfilList *WspList1 = new TProfilList();
		TProfilList *WspList2 = new TProfilList();
		TProfilList *WspList3 = new TProfilList();
		TProfilList *WspList4 = new TProfilList();
		TProfilList *WspList5 = new TProfilList();
		TProfilList *WspList6 = new TProfilList();

		LoadWsp(WSPFILE4, WspList1, "Dies ist ein langer Bezeichner", 8);
		LoadWsp(WSPFILE4, WspList2, "Ein \"sehr\" langer Bezeichner", 8);
		LoadWsp(WSPFILE4, WspList3, "Bez \\ Mez", 8);
		LoadWsp(WSPFILE4, WspList4, "Normal  ", 8);
		LoadWsp(WSPFILE4, WspList5, " Einfach  ", 8);
		LoadWsp(WSPFILE4, WspList6, "  Langabernormal   ", 8);

		if (WspList1->size() != 11)			printf("Failed\n");
		else if (WspList2->size() != 10)	printf("Failed\n");
		else if (WspList3->size() != 9)		printf("Failed\n");
		else if (WspList4->size() != 8)		printf("Failed\n");
		else if (WspList5->size() != 7)		printf("Failed\n");
		else if (WspList6->size() != 0)		printf("Failed\n");
		else								printf("Pass\n");

		delete WspList1;
		delete WspList2;
		delete WspList3;
		delete WspList4;
		delete WspList5;
		delete WspList6;
	}

	////////////////////////////////////////
	// Test von WSP als WST (neues Format) laden
	////////////////////////////////////////

	{
		printf ("Test Wasserstnde als WST laden:                                     ");

		TProfilList *WspList1 = new TProfilList();
		TProfilList *WspList2 = new TProfilList();
		TProfilList *WspList3 = new TProfilList();
		TProfilList *WspList4 = new TProfilList();

		LoadWsp(WSPFILE5, WspList1, "Demo-1960", 8);
		LoadWsp(WSPFILE5, WspList2, "Demo-1970", 8);
		LoadWsp(WSPFILE5, WspList3, "Demo-1980", 8);
		LoadWsp(WSPFILE5, WspList4, "Demo-1990", 8);

		if (WspList1->size() != 14)			printf("Failed\n");
		else if (WspList2->size() != 12)	printf("Failed\n");
		else if (WspList3->size() != 25)	printf("Failed\n");
		else if (WspList4->size() != 20)	printf("Failed\n");
		else								printf("Pass\n");

		delete WspList1;
		delete WspList2;
		delete WspList3;
		delete WspList4;
	}

	////////////////////////////////////////
	// Test von Achse laden
	////////////////////////////////////////

	{
		printf ("Test Gewsserachse laden:                                            ");

		TGewaesserAchseList *AchsenList = new TGewaesserAchseList();

		LoadAchse(ACHSEFILE, AchsenList, 8);

		TGewaesserAchse* Achse = *AchsenList->begin();

		if (AchsenList->size() != 1)				printf("Failed\n");
		else if (Achse->PointList->size() != 4788)	printf("Failed\n");
		else										printf("Pass\n");

		delete AchsenList;
	}

	////////////////////////////////////////
	// Test von Grenze laden
	////////////////////////////////////////

	{
		printf ("Test Hydraulische Grenze laden:                                      ");

		TXYZList *Gebiet = new TXYZList();

		LoadGebiet(GRENZEFILE, Gebiet, 8);

		if (Gebiet->size() != 14)	printf("Failed\n");
		else						printf("Pass\n");

		delete Gebiet;
	}

	/////////////////////////////////////////////////
	// Test von DGM-TIN ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-TIN ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMTINFILE, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 114)			printf("Failed\n");
		else if (ElementList->size() != 218)	printf("Failed\n");
		else									printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-TIN mit Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-TIN mit Begrenzungspolygon laden:                           ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();
		TXYZList *XyList = new TXYZList();

		XyList->Add(new TXYZ(807711500, 246716800));
		XyList->Add(new TXYZ(807711500, 262559500));
		XyList->Add(new TXYZ(826648700, 262559500));
		XyList->Add(new TXYZ(826648700, 246716800));

		LoadDGM(DGMTINFILE, NodeList, ElementList, XyList, 8);

		if (NodeList->size() != 71)				printf("Failed\n");
		else if (ElementList->size() != 110)	printf("Failed\n");
		else									printf("Pass\n");

		delete XyList;
		delete ElementList;
		delete NodeList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-TIN2 ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-TIN2 ohne Begrenzungspolygon laden:                         ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMTINFILE2, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 19)			printf("Failed\n");
		else if (ElementList->size() != 28)	printf("Failed\n");
		else								printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-TIN3 ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
/*
		printf ("Test DGM-TIN3 ohne Begrenzungspolygon laden:                         ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMTINFILE3, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 52)			printf("Failed\n");
		else if (ElementList->size() != 72)	printf("Failed\n");
		else								printf("Pass\n");

		delete NodeList;
		delete ElementList;
*/
	}


	/////////////////////////////////////////////////
	// Test von DGM-GRD mit Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-GRD mit Begrenzungspolygon laden:                           ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();
		TXYZList *XyList = new TXYZList();

		XyList->Add(new TXYZ(807811000, 246716800));
		XyList->Add(new TXYZ(807811000, 262559500));
		XyList->Add(new TXYZ(826648700, 262559500));
		XyList->Add(new TXYZ(826648700, 246716800));

		LoadDGM(DGMGRDFILE, NodeList, ElementList, XyList, 8);

		if (NodeList->size() != 24624)	printf("Failed\n");
		else							printf("Pass\n");

		delete XyList;
		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-XYZ ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-XYZ ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMXYZFILE, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 10)	printf("Failed\n");
		else						printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-XYZ ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-XYZ ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMXYZFILE2, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 1126)	printf("Failed\n");
		else							printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-XYZ ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-XYZ ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMXYZFILE3, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 43332)	printf("Failed\n");
		else							printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-XYZ ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-XYZ ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMXYZFILE4, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 98636)	printf("Failed\n");
		else							printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-SHP ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-SHP ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMSHPFILE, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 114)	printf("Failed\n");
		else							printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	////////////////////////////////////////
	// Test von Grenze laden
	////////////////////////////////////////

/*
	{
		printf ("Test Hydraulische Grenze mit Lchern laden:                          ");

		TXYZList *Gebiet = new TXYZList();

		LoadGebiet(GRENZEFILE2, Gebiet, 8);

		if (Gebiet->size() != 17)	printf("Failed\n");
		else						printf("Pass\n");

		delete Gebiet;
	}
*/

	/////////////////////////////////////////////////
	// Test von DGM-SHP mit Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-SHP mit Begrenzungspolygon laden:                           ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();
		TXYZList *XyList = new TXYZList();

		XyList->Add(new TXYZ(349478100, 587483400));
		XyList->Add(new TXYZ(349478100, 587493600));
		XyList->Add(new TXYZ(349516400, 587493600));
		XyList->Add(new TXYZ(349516400, 587483400));

		LoadDGM(DGMSHPFILE2, NodeList, ElementList, XyList, 8);

		if (NodeList->size() != 28287)	printf("Failed\n");
		else							printf("Pass\n");

		delete XyList;
		delete NodeList;
		delete ElementList;
	}

	/////////////////////////////////////////////////
	// Test von DGM-2DM ohne Begrenzungspolygon laden
	/////////////////////////////////////////////////

	{
		printf ("Test DGM-2DM ohne Begrenzungspolygon laden:                          ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGM2DMFILE, NodeList, ElementList, 0, 8);

		if (NodeList->size() != 1126)			printf("Failed\n");
		else if (ElementList->size() != 2225)	printf("Failed\n");
		else									printf("Pass\n");

		delete NodeList;
		delete ElementList;
	}

	printf ("*************************************************************************\n");
}
