//
// $Id: test_profil.cpp 37 2006-03-13 23:53:00Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#define DGMSHPFILE		"test_daten\\dgm.shp"
#else
#define DGMSHPFILE		"test_daten/dgm.shp"
#endif

//---------------------------------------------------------------------------
#include <stdio.h>

#include "file.h"
#include "xy.h"

//---------------------------------------------------------------------
void test_nodes(void)
{
	////////////////////////////////////////
	// Test der Knoten und Elementverwaltung
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test Knotenverwaltung\n");

	{
		printf ("Test Knoten:                                                         ");

		TNode *P11 = new TNode(1, 1, 1, 0);
		TNode *P12 = new TNode(2, 9, 1, 0);
		TNode *P13 = new TNode(3, 9, 9, 0);
		TNode *P14 = new TNode(4, 1, 9, 0);
		TNode *P15 = new TNode(5, 4, 9, 0);
		TNode *P16 = new TNode(6, 7, 9, 0);
		TNode *P17 = new TNode(7, 7, 7, 0);

		TNode *P21 = new TNode(1, 3, 4, 1);
		TNode *P22 = new TNode(2, 7, 4, 2);
		TNode *P23 = new TNode(3, 7, 6, 3);
		TNode *P24 = new TNode(4, 3, 6, 4);
		TNode *P25 = new TNode(5, 4, 5, 5);

		TNode *P31 = new TNode(P21);
		TNode *P32 = new TNode(2, 7, 7, 7, 7);

		// Jetzt zwei leere KnotenListen generieren
		TNodeList *PL1 = new TNodeList();
		TNodeList *PL2 = new TNodeList();

		// Ein paar Punkte zur ersten Polylinie zuweisen
		PL1->Add(P11);
		PL1->Add(P12);
		PL1->Add(P13);
		PL1->Add(P14);
		PL1->Add(P15);
		PL1->Add(P16);
		PL1->Add(P17);

		// Ein paar Punkte zur zweiten Polylinie zuweisen
		PL2->Add(P21);
		PL2->Add(P22);
		PL2->Add(P23);
		PL2->Add(P24);
		PL2->Add(P25);

		// Die zweite Knotenliste verdoppeln
		// Dabei werden alle Punkte mit verdoppelt

		TNodeList *PL3 = PL2->Copy();

		// Und noch zwei Punkte dazu
		PL3->Add(P31);
		PL3->Add(P32);

		int NrSumme = 0;
		long XSumme = 0;
		long YSumme = 0;
		int ZSumme = 0;
		int WspSumme = 0;

		for (TNodeList::iterator i = PL1->begin(); i != PL1->end(); i++)
		{
			TNode* Node = *i;

			NrSumme = NrSumme + Node->Nr;
			XSumme = XSumme + Node->X;
			YSumme = YSumme + Node->Y;
			ZSumme = ZSumme + Node->Z;
			WspSumme = WspSumme + Node->Wsp;
		}

		for (TNodeList::iterator i = PL2->begin(); i != PL2->end(); i++)
		{
			TNode* Node = *i;

			NrSumme = NrSumme + Node->Nr;
			XSumme = XSumme + Node->X;
			YSumme = YSumme + Node->Y;
			ZSumme = ZSumme + Node->Z;
			WspSumme = WspSumme + Node->Wsp;
		}

		for (TNodeList::iterator i = PL3->begin(); i != PL3->end(); i++)
		{
			TNode* Node = *i;

			NrSumme = NrSumme + Node->Nr;
			XSumme = XSumme + Node->X;
			YSumme = YSumme + Node->Y;
			ZSumme = ZSumme + Node->Z;
			WspSumme = WspSumme + Node->Wsp;
		}

		if (PL1->size() != 7 || PL2->size() != 5 || PL3->size() != 7)	printf("Failed\n");
		else if (NrSumme != 61 || XSumme != 96 || YSumme != 106)		printf("Failed\n");
		else if (ZSumme != 38 || WspSumme != -17999975)					printf("Failed\n");
		else															printf("Pass\n");
	}

	{
		printf ("Test Knoten Sortieren:                                               ");

		TNode *P11 = new TNode(3, 1, 1, 0);
		TNode *P12 = new TNode(2, 9, 1, 0);
		TNode *P13 = new TNode(1, 9, 9, 0);
		TNode *P14 = new TNode(4, 1, 9, 0);
		TNode *P15 = new TNode(7, 4, 9, 0);
		TNode *P16 = new TNode(6, 7, 9, 0);
		TNode *P17 = new TNode(5, 7, 7, 0);

		// Jetzt eine leere KnotenListe generieren
		TNodeList *PL1 = new TNodeList();

		// Ein paar Punkte zur ersten Polylinie zuweisen
		PL1->Add(P11);
		PL1->Add(P12);
		PL1->Add(P13);
		PL1->Add(P14);
		PL1->Add(P15);
		PL1->Add(P16);
		PL1->Add(P17);

		// Der letzt Knoten
		TNode *Node1 = *PL1->begin();
		TNode *Node2 = *PL1->rbegin();

		PL1->SortByNr();

		TNode *Node3 = *PL1->begin();
		TNode *Node4 = *PL1->rbegin();

		if (Node1->Nr != 3 || Node2->Nr != 5)		printf("Failed\n");
		else if (Node3->Nr != 1 || Node4->Nr != 7)	printf("Failed\n");
		else								   		printf("Pass\n");
	}

	{
		printf ("Test Knoten Suchen:                                                  ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMSHPFILE, NodeList, ElementList, 0, 8);

		NodeList->SortByXY();

		TNode* Node1 = NodeList->FindByXY(808089533,262365914);

		TNodeList *FoundList = NodeList->FindAllByXY(808089533, 262365914, 3000000.0);

		TNode* Node2 = *FoundList->begin();
		TNode* Node3 = *FoundList->rbegin();

		if (Node1 == 0 || Node1->Nr != 46)			printf("Failed\n");
		else if (Node2 == 0 || Node2->Nr != 54)		printf("Failed\n");
		else if (Node3 == 0 || Node3->Nr != 35)		printf("Failed\n");
		else if (FoundList->size() != 4)			printf("Failed\n");
		else										printf("Pass\n");
	}

	printf ("*************************************************************************\n");
}

