//
// $Id: test_qhull.cpp 101 2008-07-10 09:20:12Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#include <stdio.h>

#include "xy.h"
#include "file.h"
#include "qhull.h"

//---------------------------------------------------------------------
void test_qhull(void)
{
	////////////////////////////////////////
	// Test der Bildung der konvexen Hlle
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test Konvexe Hlle\n");

	{
		printf ("Test QHull 3 Knoten:                                                 ");

		// Zuerst ein paar Punkte generieren
		TXYZ *Xy1 = new TXYZ(1, 1);
		TXYZ *Xy2 = new TXYZ(2, 9);
		TXYZ *Xy3 = new TXYZ(3, 5);

		TXYZList *XyList = new TXYZList();

		XyList->push_back(Xy1);
		XyList->push_back(Xy2);
		XyList->push_back(Xy3);

		TXYZList* Polygon = new TXYZList();
		QHull(XyList, Polygon, 8);

		if (Polygon->size() != 3)  		printf("Failed\n");
		else							printf("Pass\n");

//		SavePolygon("Ergebnisse\\Test.shp", Polygon, 8);

		delete XyList;
        Polygon->clear();
        delete Polygon;
	}

	{
		printf ("Test QHull 5 Knoten:                                                 ");

		// Zuerst ein paar Punkte generieren
		TXYZ *Xy1 = new TXYZ(1, 1);
		TXYZ *Xy2 = new TXYZ(2, 9);
		TXYZ *Xy3 = new TXYZ(3, 5);
		TXYZ *Xy4 = new TXYZ(2, 4);
		TXYZ *Xy5 = new TXYZ(5, 3);

		TXYZList *XyList = new TXYZList();

		XyList->push_back(Xy1);
		XyList->push_back(Xy2);
		XyList->push_back(Xy3);
		XyList->push_back(Xy4);
		XyList->push_back(Xy5);

		TXYZList* Polygon = new TXYZList();
		QHull(XyList, Polygon, 8);

		if (Polygon->size() != 3)  		printf("Failed\n");
		else							printf("Pass\n");

//		SavePolygon("Ergebnisse\\Test.shp", Polygon, 8);

		delete XyList;
        Polygon->clear();
        delete Polygon;
	}

	{
		printf ("Test QHull 5 Knoten (Quadrat):                                       ");

		// Zuerst ein paar Punkte generieren
		TXYZ *Xy1 = new TXYZ(1, 1);
		TXYZ *Xy2 = new TXYZ(3, 1);
		TXYZ *Xy3 = new TXYZ(3, 3);
		TXYZ *Xy4 = new TXYZ(1, 3);
		TXYZ *Xy5 = new TXYZ(2, 2);

		TXYZList *XyList = new TXYZList();

		XyList->push_back(Xy1);
		XyList->push_back(Xy2);
		XyList->push_back(Xy3);
		XyList->push_back(Xy4);
		XyList->push_back(Xy5);

		TXYZList* Polygon = new TXYZList();
		QHull(XyList, Polygon, 8);

		if (Polygon->size() != 4)  		printf("Failed\n");
		else							printf("Pass\n");

//		SavePolygon("Ergebnisse\\Test.shp", Polygon, 8);

		delete XyList;
        Polygon->clear();
        delete Polygon;
	}

	{
		printf ("Test QHull 5 Knoten (Raute):                                         ");

		// Zuerst ein paar Punkte generieren
		TXYZ *Xy1 = new TXYZ(1, 1);
		TXYZ *Xy2 = new TXYZ(3, 1);
		TXYZ *Xy3 = new TXYZ(2, 3);
		TXYZ *Xy4 = new TXYZ(0, 3);
		TXYZ *Xy5 = new TXYZ(2, 2);

		TXYZList *XyList = new TXYZList();

		XyList->push_back(Xy1);
		XyList->push_back(Xy2);
		XyList->push_back(Xy3);
		XyList->push_back(Xy4);
		XyList->push_back(Xy5);

		TXYZList* Polygon = new TXYZList();
		QHull(XyList, Polygon, 8);

		if (Polygon->size() != 4)  		printf("Failed\n");
		else							printf("Pass\n");

//		SavePolygon("Ergebnisse\\Test.shp", Polygon, 8);

		delete XyList;
        Polygon->clear();
        delete Polygon;
	}

	printf ("*************************************************************************\n");

}
